# Generated by go2rpm 1.6.0
%bcond_without check

# https://github.com/yggdrasil-network/yggdrasil-go
%global goipath         github.com/yggdrasil-network/yggdrasil-go
Version:                0.5.12

%gometa

%global goname          yggdrasil-go

%global common_description %{expand:
An experiment in scalable routing as an encrypted IPv6 overlay network.}

%global golicenses      LICENSE
%global godocs          README.md CHANGELOG.md

Name:           %{goname}
Release:        2%{?dist}.78
Summary:        An experiment in scalable routing as an encrypted IPv6 overlay network

License:        LGPL-3.0-only
URL:            %{gourl}
Source0:        https://%{goipath}/archive/v%{version}/yggdrasil-go-%{version}.tar.gz
Source1:        yggdrasil.service
Source2:        yggdrasil-default-config.service
Source3:        yggdrasil.sysusers
Patch0:         yggdrasil-fix-paths.patch
Patch1:         yggdrasil-sd_notify.patch
Patch2:         yggdrasil-no-anet-dep.patch
Patch4:         yggdrasil-no-openbsd-unveil-1.patch
Patch5:         yggdrasil-no-openbsd-unveil-2.patch
BuildRequires:  go-rpm-macros
BuildRequires:  systemd-rpm-macros
%if 0%{?rhel} || 0%{?centos}
BuildRequires:  go-rpm-macros-epel
%endif

%description
%{common_description}

%gopkg

%prep
%goprep
%autopatch -p1

%generate_buildrequires
%go_generate_buildrequires

%build
for cmd in cmd/* ; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done
for cmd in contrib/ansible; do
  %gobuild -o %{gobuilddir}/bin/$(basename $cmd) %{goipath}/$cmd
done

%install
%gopkginstall
install -m 0755 -vd %{buildroot}%{_sysconfdir}/yggdrasil
install -m 0755 -vd %{buildroot}%{_sbindir}
install -m 0755 -vp %{gobuilddir}/bin/yggdrasil \
                    %{buildroot}%{_sbindir}/yggdrasil
install -m 0755 -vp %{gobuilddir}/bin/yggdrasilctl \
                    %{buildroot}%{_sbindir}/yggdrasilctl
install -m 0755 -vp %{gobuilddir}/bin/genkeys \
                    %{buildroot}%{_sbindir}/yggdrasil-genkeys
install -m 0755 -vd %{buildroot}%{_unitdir}
install -m 0644 -vp %{SOURCE1} %{buildroot}%{_unitdir}/
install -m 0644 -vp %{SOURCE2} %{buildroot}%{_unitdir}/
install -m 0755 -vd %{buildroot}%{_sysusersdir}
install -m 0644 -vp %{SOURCE3} %{buildroot}%{_sysusersdir}/yggdrasil.conf

%if %{with check}
%check
%gocheck
%endif

%pre
%sysusers_create_compat %{SOURCE3}

%post
%systemd_post yggdrasil.service

%preun
%systemd_preun yggdrasil.service

%postun
%systemd_postun_with_restart yggdrasil.service

%files
%license LICENSE
%doc README.md CHANGELOG.md
%dir %{_sysconfdir}/yggdrasil
%{_sbindir}/yggdrasil
%{_sbindir}/yggdrasilctl
%{_sbindir}/yggdrasil-genkeys
%{_unitdir}/yggdrasil*.service
%{_sysusersdir}/yggdrasil.conf

%gopkgfiles

%changelog
* Tue Apr  1 2025 Oleg Girko <ol@infoserver.lv> - 0.5.12-2
- Remove patch reverting websocket to older goipath
* Fri Dec 27 2024 Oleg Girko <ol@infoserver.lv> - 0.5.12-1
- Update to 0.5.12
* Wed Nov 27 2024 Oleg Girko <ol@infoserver.lv> - 0.5.10-1
- Update to 0.5.10
* Sat Nov  2 2024 Oleg Girko <ol@infoserver.lv> - 0.5.9-1
- Update to 0.5.9
* Sun Oct 20 2024 Oleg Girko <ol@infoserver.lv> - 0.5.8-2
- Use %%autopatch instead of manually applying every patch
- Require go-rpm-macros-epel for build in RHEL and CentOS
* Mon Aug 12 2024 Oleg Girko <ol@infoserver.lv> - 0.5.8-1
- Update to 0.5.8
* Mon Aug  5 2024 Oleg Girko <ol@infoserver.lv> - 0.5.7-1
- Update to 0.5.7
* Sat Jun 15 2024 Oleg Girko <ol@infoserver.lv> - 0.5.6-2
- Add patch to implement service startup complete notification using sd_notify
* Fri May 31 2024 Oleg Girko <ol@infoserver.lv> - 0.5.6-1
- Update to 0.5.6
* Wed Apr 17 2024 Oleg Girko <ol@infoserver.lv> - 0.5.5-1
- Update to 0.5.5
- Don't package doc and license files from contrib
* Sun Nov 20 2022 Oleg Girko <ol@infoserver.lv> - 0.4.7-1
- Update to 0.4.7
* Wed Oct 26 2022 Oleg Girko <ol@infoserver.lv> - 0.4.6-1
- Update to 0.4.6
* Tue Oct 18 2022 Oleg Girko <ol@infoserver.lv> - 0.4.5-1
- Update to 0.4.5
- Use dynamic buildrequires
* Thu Jul  7 2022 Oleg Girko <ol@infoserver.lv> - 0.4.4-1
- Update to 0.4.4
* Sun Feb  6 2022 Oleg Girko <ol@infoserver.lv> - 0.4.3-1
- Initial package
